[PATCH] devtools: add cppcheck wrapper

Stephen Hemminger stephen at networkplumber.org
Tue Jun 13 01:55:16 CEST 2023


From: Ferruh Yigit <ferruh.yigit at intel.com>

Adding wrapper script for cppcheck code analysis tool.

usage: cppcheck.sh [-h] [cppcheck options] [path]

Example:
 $ ./devtools/cppcheck.sh -q lib/ethdev/

The tool is useful but gets confused by macros in parts of DPDK.
It identified some bogus code in netvsc driver, and some possible
issues in pcapng.

Would also like to do another round of dead code squashing

Revised and simplified from original version by Ferruh Yigit.
Let the user redirect output as they want, and allow passing
options such as -q (quiet) and -v (verbose).

Signed-off-by: Stephen Hemminger <stephen at networkplumber.org>
---
 devtools/cppcheck.sh | 59 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 59 insertions(+)
 create mode 100755 devtools/cppcheck.sh

diff --git a/devtools/cppcheck.sh b/devtools/cppcheck.sh
new file mode 100755
index 000000000000..df885df61423
--- /dev/null
+++ b/devtools/cppcheck.sh
@@ -0,0 +1,59 @@
+#! /bin/sh
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright(c) 2021 Intel Corporation
+
+# wrapper script for cppcheck code analysis tool
+# Args:
+#   $1: path to scan (optional)
+
+CPPCHECK_BIN=cppcheck
+RTE_CONFIG=./build/rte_build_config.h
+
+which $CPPCHECK_BIN > /dev/null 2> /dev/null
+if [ $? -ne 0 ]; then
+	echo "$CPPCHECK_BIN is missing!" >&2
+	exit 1
+fi
+
+if [ ! -r $RTE_CONFIG ]; then
+	echo "Build not configured missing $RTE_CONFIG" >&2
+	exit 1
+fi
+
+print_usage () {
+	cat <<- END_OF_HELP
+	usage: $(basename $0) [-h] [cppcheck options] [file or path]
+
+	Run Linux cppcheck tool with DPDK options.
+
+	END_OF_HELP
+}
+
+if [ "$1" = "-h" ]; then
+	print_usage
+	exit 1;
+fi
+
+suppress_args="
+	--suppress=invalidPrintfArgType_sint \
+	--suppress=invalidPrintfArgType_uint \
+	--suppress=duplicateAssignExpression \
+	--suppress=nullPointerRedundantCheck \
+	--suppress=identicalConditionAfterEarlyExit \
+	--suppress=objectIndex \
+	--suppress=unknownMacro \
+	"
+
+includes="
+	--include=$RTE_CONFIG \
+	--includes-file=lib/eal/include \
+	--includes-file=lib/eal/linux/include \
+	"
+
+# all, warning, performance, portability,
+# information, unusedFunction, missingInclude
+additional_checks=warning
+
+${CPPCHECK_BIN}	--language=c ${includes} \
+		--enable=${additional_checks} \
+		--force ${suppress_args} $@
-- 
2.39.2



More information about the dev mailing list